import { Carta } from 'carta-md';
import { markedHighlight } from 'marked-highlight';
/**
 * Carta code highlighting plugin. Themes available on [GitHub](https://github.com/speed-highlight/core/tree/main/dist/themes).
 */
export const code = (options) => {
    return {
        markedExtensions: [
            markedHighlight({
                langPrefix: 'shj-lang-',
                async: true,
                async highlight(code, lang) {
                    lang ||= options?.defaultLanguage ?? '';
                    let highlighted = null;
                    if (lang) {
                        highlighted = await Carta.highlight(code, lang, !(options?.lineNumbering ?? false));
                    }
                    if (highlighted)
                        return highlighted;
                    if (options?.autoDetect ?? true) {
                        return await Carta.highlightAutodetect(code, !(options?.lineNumbering ?? false));
                    }
                    return (await Carta.highlight(code, 'plain', !(options?.lineNumbering ?? false)));
                }
            })
        ]
    };
};
//# sourceMappingURL=index.js.map